#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <X11/Xlib.h>
#include "cli.h"

#if defined __hpux || defined SOLARIS
#define random nrand48
#define srandom srand48
#endif

jitter ()
{
    int xoff;
    int yoff;
    int xold;
    int yold;
    int temp;
    unsigned int maskr;
    Window rr;
    Window cr;

	XGetInputFocus(dpy, &cr, &temp);
	if ( cr != win )
	    return;
	if (XQueryPointer(dpy, win, &rr, &cr, &temp, &temp, &xold, &yold, &maskr)) {

/*
	    xoff = random();
	    yoff = random();
	    xoff = xold + ((xoff%3)?0:((-1)+(2*(xoff%2))));
	    yoff = yold + ((yoff%3)?0:((-1)+(2*(yoff%2))));
*/
	    xoff = random();
	    yoff = random();
	    xoff = xold + ((xoff%2)?0:(xoff%3-1));
	    yoff = yold + ((yoff%2)?0:(yoff%3-1));
/*
	    xoff = xold + (random()%3-1);
	    yoff = yold + (random()%3-1);
*/

	    if (xoff<0) xoff = 0;
	    else if (xoff>=win_wid-1) xoff = win_wid-2;

	    if (yoff<0) yoff = 0;
	    else if (yoff>=win_hgt-1) yoff = win_hgt-2;

	    if (xoff!=xold || yoff!=yold)
		XWarpPointer(dpy, None, win, 0, 0, 0, 0, xoff, yoff);

	    XSync(dpy, 0);
	}
}
