#include <stdio.h>
#include <X11/Xlib.h>
#include "cli.h"

extern void redraw_field(), title_redraw();
phand phands[MAXPLAYERS];

void run_tick()
{
    int xpos, ypos;
    msg_cupdate msg;
    Window root_return, child_return; 
    int root_x_return, root_y_return; 
    int win_x_return, win_y_return; 
    unsigned int mask_return; 
    point mouse;

    tick++;

    msg.type = mtype_cupdate;
    msg.handx = hand.x;
    msg.handy = hand.y;
    if (pieceheld != (-1)) {
	msg.rot = pieces[pieceheld].rot;
	msg.attack = pieces[pieceheld].attack;
    }
    sendmsg(&msg);
}

void run_stick(msg)
msg_stick *msg;
{
    int gx, piecenum;

    /*printf("stik: held = %d\n", pieceheld);*/

    if (majormode == MAJMODE_IN) {
	/* fill in phands[] array */
	/* pull data from stick for each player *except* self */
	for (gx=0; gx<msg->numgamers; gx++) {
	    if (gx!=gamernum) {
		phands[gx].p.x = msg->s[gx].x;
		phands[gx].p.y = msg->s[gx].y;
		phands[gx].holding = msg->s[gx].piecenum;
		if (phands[gx].holding != (-1)) {
		    piecenum = phands[gx].holding;
		    pieces[piecenum].x = phands[gx].p.x;
		    pieces[piecenum].y = phands[gx].p.y;
		    pieces[piecenum].rot = msg->s[gx].rot;
		    pieces[piecenum].attack = msg->s[gx].attack;
		}
	    }
	    else { /* for self, put correct data in phands[] */
		phands[gx].p.x = hand.x;
		phands[gx].p.y = hand.y;
		if (pieceheld != (-1)) {
		    pieces[pieceheld].x = hand.x;
		    pieces[pieceheld].y = hand.y;
		}
	    }
	}

	redraw_field(); /* ### yeeccchh. */
    }
    else {
	numgamers = msg->numgamers;
	title_numgamers_redraw();
    }
}
