#include <stdio.h>
#include "ser.h"

static short usemaximum[NUMOPTIONS] = {0, 0, 0};

void review_option();

void init_options()
{
    int ix;
    for (ix=0; ix<NUMOPTIONS; ix++) {
	optionval[ix] = 0;
    }
}

void change_option(plernum, opnum, val)
int plernum, opnum, val;
{
    if (plers[plernum].reqoption[opnum] == val)
	return;

    if (opnum==OPT_WANTSTART && val && !plers[plernum].sig) {
	/* has no sig; don't let him start */
	msg_notify msg;
	msg.type = mtype_notify;
	msg.what = NOTIFY_NEED_SIG_FILE;
	sendmsg(active_client, &msg);
	return;
    }

    plers[plernum].reqoption[opnum] = val;

    review_option(opnum);
}

void review_all_options()
{
    int ix;

    for (ix=0; ix<NUMOPTIONS; ix++)
	review_option(ix);
}

void review_option(opnum)
int opnum;
{
    clref cx;
    msg_changeoption msg;
    int ix, newval;

    if (usemaximum[opnum]) {
	newval = -99999;
	for (cx=0; cx<connections; cx++) {
	    ix = clients[cx]->playernum;
	    if (plers[ix].reqoption[opnum] > newval)
		newval = plers[ix].reqoption[opnum];
	}
    }
    else  {
	newval = 99999;
	for (cx=0; cx<connections; cx++) {
	    ix = clients[cx]->playernum;
	    if (plers[ix].reqoption[opnum] < newval)
		newval = plers[ix].reqoption[opnum];
	}
    }

    if (newval == optionval[opnum])
	return;

    optionval[opnum] = newval;

    msg.type = mtype_changeoption;
    msg.opnum = opnum;
    msg.newval = newval;
    for (cx=0; cx<connections; cx++) {
	sendmsg(cx, &msg);
    }

    if (opnum==OPT_WANTSTART && newval) {
	/* game starts */
	init_board(); 
    }
}
