#include <stdio.h>
#include <sys/time.h>
#include "ser.h"

long tick;
int gamemode;
short numgamers;
gamer *gamers = NULL;
piece *pieces = NULL;
short numpieces;
zone board;
double worldxmin, worldxmax, worldymin, worldymax;

/* game-level status switches */
int optionval[NUMOPTIONS];

extern int incoming_sock;

extern void init_server(), server_loop(), take_client(), take_incoming(), do_quit();
extern void init_game(), run_tick();
extern clref wait_for();

main(argc, argv)
int argc;
char *argv[];
{
/*  struct timeval ttp;*/

    active_client = ERROR;

/*  srandom(getpid());*/

    printf("### xicehouse server\n");
/*  (void)gettimeofday(&ttp, (struct timezone *)NULL);*/
/*  srandom((int)(ttp.tv_sec + ttp.tv_usec));*/

    tick = 0;

    init_game();

    server_loop();

    return 0;
}

void server_loop() /* does not return */
{
    clref ix, new_client;
    int new_sock;

    init_server();

    while (1) {
	new_client = wait_for(clients, connections, incoming_sock);
	if (new_client==(-3)) {
	    run_tick();
	}
	else if (new_client==(-1)) {
	    take_incoming(incoming_sock);
	}
	else if (new_client != (-2)) {
	    take_client(new_client);
	};

	for (ix=connections-1; ix>=0; ix--) {
	    if (clients[ix]->quit_flag)
		do_quit(ix);
	}
    }
}

